; Written by Four-F (four-f@mail.ru)

.386
.model flat, stdcall
option casemap:none

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                  I N C L U D E   F I L E S                                        
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

include \masm32\include\windows.inc

include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

include \masm32\cocomac\cocomac.mac
include \masm32\cocomac\TreeView.mac

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                        M A C R O S                                                
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

$invoke MACRO vars:VARARG
     invoke vars
     EXITM <eax>
ENDM

m2m MACRO Des:REQ, Sor:REQ
    push Sor
	pop  Des		
ENDM

date MACRO
	% FORC chr, @Date
		db "&chr"
	ENDM
ENDM

$TA0 MACRO sText
local szDummy
	.data
	IFNB <sText>
		szDummy db sText, 0
	ELSE
		szDummy db 0
	ENDIF
	.code
	EXITM <offset szDummy>
ENDM

$LOWORD MACRO dwVar:REQ
	IF $IsImm(dwVar)
		EXITM <dwVar AND 0FFFFh>
	ELSE
		IFDIFI <dwVar>, <eax>	;; don't move eax onto itself
			mov eax, dwVar
		ENDIF
		and eax, 0FFFFh
		EXITM <eax>
	ENDIF
ENDM

$HIWORD MACRO dwVar:REQ
	IF $IsImm(dwVar)
		EXITM <dwVar SHR 16>
	ELSE
		IFDIFI <dwVar>, <eax>	;; don't move eax onto itself
			mov eax, dwVar
		ENDIF
		shr eax, 16
		EXITM <eax>
	ENDIF
ENDM

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                         F U N C T I O N S   P R O T O T Y P E S                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

DlgProc proto :HWND, :UINT, :WPARAM, :LPARAM

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                     C O N S T A N T S                                             
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.const
IDD_DIALOG			equ	1000
IDC_TREEVIEW		equ	1001
IDI_ICON			equ	2000
IDI_NRM_BITMAP		equ 2001
IDI_CHK_BITMAP		equ 2002

IDM_ABOUT			equ	3000

NUM_NRM_IMAGES		equ 6
NUM_CHK_IMAGES		equ 2

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                              I N I T I A L I Z E D  D A T A                                       
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.data
szTreeViewClassName		db "SysTreeView32", 0
szAbout					db "About...", 0
szWrittenBy				db "Written by Four-F ("
						date
						db ")", 0Ah, 0Dh, "four-f@mail.ru", 0

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                              U N I N I T I A L I Z E D  D A T A                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.data?
g_hInstance				HINSTANCE	?
g_hwndTreeView			HWND		?
g_hImageListNrm			HANDLE		?
g_hImageListChk			HANDLE		?

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                       C O D E                                                     
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

.code

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

FillTreeView proc uses esi ebx

LOCAL tvins:TV_INSERTSTRUCT
LOCAL hRoot:HANDLE
LOCAL hStop:HANDLE
LOCAL hHome:HANDLE
LOCAL hTools:HANDLE
LOCAL hSettings:HANDLE

	lea esi, tvins
	assume esi:ptr TV_INSERTSTRUCT
	mov [esi].hParent, NULL
	mov [esi].hInsertAfter, TVI_ROOT
	mov [esi].item.imask, TVIF_TEXT + TVIF_SELECTEDIMAGE + TVIF_IMAGE
	mov [esi].item.pszText, $TA0("Root")
	mov [esi].item.iImage, 0
	mov [esi].item.iSelectedImage, 0 + NUM_NRM_IMAGES
	TreeView_InsertItem g_hwndTreeView, esi

	mov hRoot, eax

	mov [esi].hParent, eax
	mov [esi].hInsertAfter, TVI_LAST
	or [esi].item.imask, TVIF_STATE + TVIS_STATEIMAGEMASK
	mov [esi].item.state, (2 SHL 12)					; checked
	mov [esi].item.stateMask, TVIS_STATEIMAGEMASK
	mov [esi].item.pszText, $TA0("Stop")
	inc [esi].item.iImage
	inc [esi].item.iSelectedImage
	TreeView_InsertItem g_hwndTreeView, esi

	mov hStop, eax

	mov [esi].item.state, (1 SHL 12)					; unchecked
	mov [esi].item.pszText, $TA0("Home")
	inc [esi].item.iImage
	inc [esi].item.iSelectedImage
	TreeView_InsertItem g_hwndTreeView, esi

	mov hHome, eax

	mov [esi].item.state, (2 SHL 12)					; checked
	mov [esi].item.pszText, $TA0("Tools")
	inc [esi].item.iImage
	inc [esi].item.iSelectedImage
	TreeView_InsertItem g_hwndTreeView, esi

	mov hTools, eax

	mov [esi].item.state, (1 SHL 12)					; unchecked
	mov [esi].item.pszText, $TA0("Settings")
	inc [esi].item.iImage
	inc [esi].item.iSelectedImage
	TreeView_InsertItem g_hwndTreeView, esi

	mov hSettings, eax

	mov [esi].item.iImage, 5
	mov [esi].item.iSelectedImage, 5 + NUM_NRM_IMAGES

	xor ebx, ebx
	.while ebx < 4
		m2m [esi].hParent, hSettings[ebx*(sizeof HANDLE)]
		TreeView_GetCheckState g_hwndTreeView, [esi].hParent
		.if eax == 0									; unchecked
			mov [esi].item.state, (1 SHL 12)
		.elseif eax == 1								; checked
			mov [esi].item.state, (2 SHL 12)
		.endif
		mov [esi].item.pszText, $TA0("item1")
		TreeView_InsertItem g_hwndTreeView, esi

		mov [esi].item.pszText, $TA0("item2")
		TreeView_InsertItem g_hwndTreeView, esi

		mov [esi].item.pszText, $TA0("item3")
		TreeView_InsertItem g_hwndTreeView, esi

		inc ebx
	.endw

	TreeView_Expand g_hwndTreeView, hRoot, TVE_EXPAND

	ret

FillTreeView endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

CheckNode proc uses ebx hwndTreeView:HWND, hNode:HANDLE

LOCAL fCheck:UINT

	TreeView_GetCheckState hwndTreeView, hNode
	.if eax == 1									; checked ?
		mov eax, FALSE								; uncheck
	.elseif eax == 0								; unchecked ?
		mov eax, TRUE								; check
	.endif
	mov fCheck, eax
	TreeView_SetCheckState hwndTreeView, hNode, eax

	TreeView_GetChild hwndTreeView, hNode
	.while eax != NULL
		mov ebx, eax
		; Item has children. Check/uncheck them
		TreeView_SetCheckState hwndTreeView, ebx, fCheck
		TreeView_GetNextSibling hwndTreeView, ebx
	.endw

	ret

CheckNode endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                 D I A L O G      P R O C E D U R E                                
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

DlgProc proc uses ebx hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

LOCAL rect:RECT
LOCAL tvhti:TV_HITTESTINFO

	mov eax, uMsg
	.if eax == WM_INITDIALOG

		; Set Dialog Icon
		invoke LoadIcon, g_hInstance, IDI_ICON
		invoke SendMessage, hDlg, WM_SETICON, ICON_BIG, eax

		; Get the dimensions of the parent window's client area
		invoke GetClientRect, hDlg, addr rect
		invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr szTreeViewClassName, NULL, \
			WS_CHILD + WS_VISIBLE + TVS_HASLINES + TVS_HASBUTTONS + TVS_LINESATROOT, \
			0, 0, rect.right, rect.bottom, hDlg, IDC_TREEVIEW, g_hInstance, NULL
		mov g_hwndTreeView, eax

		mov g_hImageListNrm, $invoke(ImageList_Create, 16, 16, ILC_COLOR24 + ILC_MASK, NUM_NRM_IMAGES, 0)
		invoke LoadBitmap, g_hInstance, IDI_NRM_BITMAP
		push eax				; for DeleteObject
		invoke ImageList_AddMasked, g_hImageListNrm, eax, Magenta
		call DeleteObject
		TreeView_SetImageList g_hwndTreeView, g_hImageListNrm, TVSIL_NORMAL


		mov g_hImageListChk, $invoke(ImageList_Create, 16, 16, ILC_COLOR24 + ILC_MASK, NUM_CHK_IMAGES, 0)
		invoke LoadBitmap, g_hInstance, IDI_CHK_BITMAP
		push eax				; for DeleteObject
		invoke ImageList_AddMasked, g_hImageListChk, eax, Magenta
		call DeleteObject
		TreeView_SetImageList g_hwndTreeView, g_hImageListChk, TVSIL_STATE

		push esi
		mov esi, $invoke(GetSystemMenu, hDlg, FALSE)
		invoke InsertMenu, esi, -1, MF_BYPOSITION + MF_SEPARATOR, 0, 0
		invoke InsertMenu, esi, -1, MF_BYPOSITION + MF_STRING, IDM_ABOUT, offset szAbout
		pop esi

		invoke FillTreeView

	.elseif eax == WM_NOTIFY
		mov ebx, lParam
		.if  wParam == IDC_TREEVIEW
			mov eax, (NMHDR ptr [ebx]).code 
            .if eax == NM_CLICK
				invoke GetMessagePos
				push eax
				mov tvhti.pt.x, $LOWORD(eax)
				pop eax
				mov tvhti.pt.y, $HIWORD(eax)

				invoke ScreenToClient, (NMHDR ptr [ebx]).hwndFrom, addr tvhti.pt
				mov eax, tvhti.pt.x

				TreeView_HitTest (NMHDR ptr [ebx]).hwndFrom, addr tvhti

				.if tvhti.flags & TVHT_ONITEMSTATEICON		; click over state icon ?
					invoke CheckNode, (NMHDR ptr [ebx]).hwndFrom, tvhti.hItem
				.endif

            .elseif eax == TVN_KEYDOWN
            	; let user check/uncheck items with space key
            	mov eax, lParam
            	.if [TV_KEYDOWN ptr [eax]].wVKey == VK_SPACE
            		TreeView_GetSelection (NMHDR ptr [ebx]).hwndFrom
					invoke CheckNode, (NMHDR ptr [ebx]).hwndFrom, eax
            	.endif
			.endif
		.endif

	.elseif eax == WM_COMMAND
		mov eax, wParam
		and eax, 0FFFFh
		.if eax == IDCANCEL
			invoke EndDialog, hDlg, 0
		.endif

	.elseif eax == WM_SYSCOMMAND
		.if wParam == IDM_ABOUT
			invoke MessageBox, hDlg, addr szWrittenBy, addr szAbout, MB_OK + MB_ICONINFORMATION
		.endif
 		xor eax, eax
 		ret

	.elseif eax == WM_DESTROY
		invoke ImageList_Destroy, g_hImageListNrm
		invoke ImageList_Destroy, g_hImageListChk

	.else

 		xor eax, eax
 		ret

	.endif

	xor eax, eax
	inc eax
	ret   
    
DlgProc endp

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                                                                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

start:
	invoke GetModuleHandle, NULL
	mov g_hInstance, eax
	invoke DialogBoxParam, g_hInstance, IDD_DIALOG, NULL, addr DlgProc, 0
	invoke ExitProcess, 0
    invoke InitCommonControls
end start